using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
//using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

using SpectrEngine.Framework;
using SpectrEngine.Framework.Input;

using CellWarzGame.Screens;
using CellWarzGame.Collections;

namespace CellWarzGame
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class CellGame : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        public Random rand;

        public CellGame()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            new ScreenManager(this);
            new CellList(this);
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            GamePadManager.TriggerThreshold = 0.3f;
            FullScreen();
            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            
            // TODO: use this.Content to load your game content here
            new MainMenuScreen(this);
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            //Update gamepad
            GamePadManager.Update();

            if (GamePadManager.IsButtonReleased(PlayerIndex.One, GamePadButtons.Back))
            {
                this.Exit();
            }

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // TODO: Add your drawing code here

            base.Draw(gameTime);
        }

        public void FullScreen()
        {
            graphics.PreferredBackBufferWidth = 1280;//graphics.GraphicsDevice.DisplayMode.Width;
            graphics.PreferredBackBufferHeight = 720;//graphics.GraphicsDevice.DisplayMode.Height;

            //graphics.IsFullScreen = true;

            graphics.ApplyChanges();
        }
    }
}
