﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using SpectrEngine.Framework;

using CellWarzGame.Actors;

namespace CellWarzGame.Screens
{
    class MainMenu : GameScreen
    {
        Texture2D backdrop;

        public MainMenu(Game game)
            : base(game)
        {
            
            this.transitionOnTime = TimeSpan.FromSeconds(1.0);

            this.transitionMask = game.Content.Load<Texture2D>("Test\\organic_fade");

            game.Services.GetService<ScreenManager>().AddScreen(this, 0);
            game.Services.AddService(typeof(IPlayScreenService), this);

            new Cell(Game, Cell.Side.blue, Cell.Controler.AI, new Vector2(400.0f, 300.0f), Cell.CellType.Monk);
            new Cell(Game, Cell.Side.green, Cell.Controler.AI, new Vector2(410.0f, 300.0f), Cell.CellType.Monk);
            new Cell(Game, Cell.Side.orange, Cell.Controler.AI, new Vector2(420.0f, 300.0f), Cell.CellType.Punk);
            new Cell(Game, Cell.Side.red, Cell.Controler.AI, new Vector2(430.0f, 300.0f), Cell.CellType.Punk);
            new Cell(Game, Cell.Side.violet, Cell.Controler.AI, new Vector2(440.0f, 300.0f), Cell.CellType.Skunk);
            new Cell(Game, Cell.Side.yellow, Cell.Controler.AI, new Vector2(450.0f, 300.0f), Cell.CellType.Skunk);

            new Cell(Game, Cell.Side.virus, Cell.Controler.player, new Vector2(460.0f, 300.0f), Cell.CellType.Virus);

            backdrop = game.Content.Load<Texture2D>(@"Background\CWZ_GamePlay_BG");
        }

        public override void Draw(Microsoft.Xna.Framework.GameTime gameTime)
        {
            Game.GraphicsDevice.Clear(Color.White);

            //spriteBatch.Begin();
            spriteBatch.Draw(backdrop, new Vector2(this.Game.GraphicsDevice.Viewport.Width / 2, this.Game.GraphicsDevice.Viewport.Height / 2), null, Color.White, 0.0f, new Vector2(backdrop.Width / 2, backdrop.Height / 2), 1.0f, SpriteEffects.None, 0.0f);
            //spriteBatch.End();


            base.Draw(gameTime);
        }

    }
}
