﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;

namespace SpectrEngine.Framework
{
    public static class GameServicesExtension
    {
        public static void AddService<TService>(this GameServiceContainer container, TService service)
        {
            container.AddService(typeof(TService), service);
        }

        public static TService GetService<TService>(this GameServiceContainer container)
        {
            return (TService)container.GetService(typeof(TService));
        }

        public static void RemoveService<TService>(this GameServiceContainer container)
        {
            container.RemoveService(typeof(TService));
        }
    }
}
